/*****************************/
/***** File: eckbox.c    *****/
/***** Main eckbox file! *****/
/*****************************/

#include <vga.h>
#include <stdio.h>
#include <sys/perm.h>
#include <math.h>
#define extern static
#include <asm/io.h>
#undef extern

#ifndef ECKBOX_H
#include "eckbox.h"
#endif
#ifndef ECKBOX_IO_H
#include "io.h"
#endif
#ifndef ECKBOX_TIMING_H
#include "timing.h"
#endif

int main (int arc, char** argv)
{
  /***** variables! *****/
  int pix, href, vref, thresh, pixel_color, k, i;

  /***** start graphics stuff *****/
  vga_init();
  vga_setmode(G800x600x256);
  
  /***** get timing stuff *****/
  timing_init ();
  pix=timing_get_pix ();
  href=timing_get_href ();
  vref=timing_get_vref ();

  /***** IO init for eckbox device *****/
  ioperm (0x378, 3, 1); /* Get permissions for parallel port.  Must be root! */
  io_set_bidirectional (0x378); /* sets parallel port bidirectional: soon to be obsolete as USB or FireWire will be used */
  
  /***** Eckbox device init *****/
  eckbox_init ();

  /***** Main program loop! *****/
  while(1)
  {
    for(k=0; k<600; k++) /* 800 pixels is one row! */
    {
      for(i=0; i<800; i++)
      {
	pixel_color=eckbox_get_pixel_color ();
	timing_sleep (pix);
	vga_setcolor (pixel_color);
	vga_drawpixel (i, k);
      }
      timing_sleep (href);
    }
    timing_sleep (vref);
  }
  return 0;
}

