/************************************/
/***** File: io.h               *****/
/***** Eckbox dev io functions! *****/
/************************************/

#include <sys/perm.h>

#define extern static
#include <asm/io.h>
#undef extern

#define ECKBOX_IO_H

/***** Function: io_set_bidirectional (int) *****/
/***** Sets port iobase bidirectional!      *****/
/***** Contributed by Mariuz Gumowski!      *****/

int io_set_bidirectional (unsigned int iobase)
{
  outb (0x66, iobase);
  (void) inb (iobase); /* wait a little */
  if (inb(iobase)!=0x66)
    return 0; /* already in bidirectional mode */
  
  outb (0xBB, iobase); /* one more test */
  (void) inb (iobase);
  if(inb(iobase)!=0xBB)
    return 0; /* sure it's in bidirectional mode */

  if(ioperm(iobase+2,1,1)) 
    return 1; /* don't have the permission, so exit: failed */
  
  outb (iobase+2, 48); /* set the bidirectional mode */
  return 0;
}
